gtkmm: Gtk::SearchEntry Class Reference

gtkmm 4.14.0

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gtk::SearchEntry Class Reference
Widgets

This is a subclass of Gtk::Entry that has been tailored for use as a search entry. More...

`#include <gtkmm/searchentry.h>`

Inheritance diagram for Gtk::SearchEntry:
[legend]

## Public Member Functions
| SearchEntry (SearchEntry &&src) noexcept
SearchEntry & | operator= (SearchEntry &&src) noexcept
| SearchEntry (const SearchEntry &)=delete
SearchEntry & | operator= (const SearchEntry &)=delete
| ~SearchEntry () noexcept override
GtkSearchEntry * | gobj ()
| Provides access to the underlying C GObject.
const GtkSearchEntry * | gobj () const
| Provides access to the underlying C GObject.
| SearchEntry ()
void | set_key_capture_widget (Widget &widget)
| Sets widget as the widget that entry will capture key events from.
Widget * | get_key_capture_widget ()
| Gets the widget that entry is capturing key events from.
const Widget * | get_key_capture_widget () const
| Gets the widget that entry is capturing key events from.
void | unset_key_capture_widget ()
void | set_search_delay (unsigned int delay)
| Set the delay to be used between the last keypress and the signal_search_changed() signal being emitted.
unsigned int | get_search_delay () const
| Get the delay to be used between the last keypress and the signal_search_changed() signal being emitted.
void | set_placeholder_text (const Glib::ustring &text)
| Sets the placeholder text associated with entry.
Glib::ustring | get_placeholder_text () const
| Gets the placeholder text associated with entry.
Glib::SignalProxy< void()> | signal_search_changed ()
Glib::SignalProxy< void()> | signal_next_match ()
Glib::SignalProxy< void()> | signal_previous_match ()
Glib::SignalProxy< void()> | signal_stop_search ()
Glib::SignalProxy< void()> | signal_search_started ()
Glib::PropertyProxy< Glib::ustring > | property_placeholder_text ()
| The text that will be displayed in the `Gtk::SearchEntry` when it is empty and unfocused.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_placeholder_text () const
| The text that will be displayed in the `Gtk::SearchEntry` when it is empty and unfocused.
Glib::PropertyProxy< bool > | property_activates_default ()
| Whether to activate the default widget when Enter is pressed.
Glib::PropertyProxy_ReadOnly< bool > | property_activates_default () const
| Whether to activate the default widget when Enter is pressed.
Glib::PropertyProxy< unsigned int > | property_search_delay ()
| The delay in milliseconds from last keypress to the search changed signal.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_search_delay () const
| The delay in milliseconds from last keypress to the search changed signal.
Public Member Functions inherited from Gtk::Entry
| Entry (Entry &&src) noexcept
Entry & | operator= (Entry &&src) noexcept
| Entry (const Entry &)=delete
Entry & | operator= (const Entry &)=delete
| ~Entry () noexcept override
GtkEntry * | gobj ()
| Provides access to the underlying C GObject.
const GtkEntry * | gobj () const
| Provides access to the underlying C GObject.
| Entry ()
| Entry (const Glib::RefPtr< EntryBuffer > &buffer)
Glib::RefPtr< EntryBuffer > | get_buffer ()
| Get the `Gtk::EntryBuffer` object which holds the text for this widget.
Glib::RefPtr< const EntryBuffer > | get_buffer () const
| Get the `Gtk::EntryBuffer` object which holds the text for this widget.
void | set_buffer (const Glib::RefPtr< EntryBuffer > &buffer)
| Set the `Gtk::EntryBuffer` object which holds the text for this widget.
void | set_visibility (bool visible=true)
| Sets whether the contents of the entry are visible or not.
bool | get_visibility () const
| Retrieves whether the text in entry is visible.
void | set_invisible_char (gunichar ch)
| Sets the character to use in place of the actual text in “password mode”.
void | unset_invisible_char ()
| Unsets the invisible char, so that the default invisible char is used again.
gunichar | get_invisible_char () const
| Retrieves the character displayed in place of the actual text in “password mode”.
void | set_has_frame (bool setting=true)
| Sets whether the entry has a beveled frame around it.
bool | get_has_frame () const
| Gets the value set by set_has_frame().
void | set_overwrite_mode (bool overwrite=true)
| Sets whether the text is overwritten when typing in the `Gtk::Entry`.
bool | get_overwrite_mode () const
| Gets whether the `Gtk::Entry` is in overwrite mode.
void | set_max_length (int max)
| Sets the maximum allowed length of the contents of the widget.
int | get_max_length () const
| Retrieves the maximum allowed length of the text in entry.
guint16 | get_text_length () const
| Retrieves the current length of the text in entry.
void | set_activates_default (bool setting=true)
| Sets whether pressing Enter in the entry will activate the default widget for the window containing the entry.
gboolean | get_activates_default () const
| Retrieves the value set by set_activates_default().
void | set_alignment (float xalign)
| Sets the alignment for the contents of the entry.
void | set_alignment (Align xalign)
| Sets the alignment for the contents of the entry.
float | get_alignment () const
| Gets the value set by set_alignment().
void | set_completion (const Glib::RefPtr< EntryCompletion > &completion)
| Sets completion to be the auxiliary completion object to use with entry.
Glib::RefPtr< EntryCompletion > | get_completion ()
| Returns the auxiliary completion object currently in use by entry.
Glib::RefPtr< const EntryCompletion > | get_completion () const
| Returns the auxiliary completion object currently in use by entry.
void | set_progress_fraction (double fraction)
| Causes the entry’s progress indicator to “fill in” the given fraction of the bar.
double | get_progress_fraction () const
| Returns the current fraction of the task that’s been completed.
void | set_progress_pulse_step (double fraction)
| Sets the fraction of total entry width to move the progress bouncing block for each pulse.
double | get_progress_pulse_step ()
| Retrieves the pulse step set with set_progress_pulse_step().
void | progress_pulse ()
| Indicates that some progress is made, but you don’t know how much.
Glib::ustring | get_placeholder_text () const
| Retrieves the text that will be displayed when entry is empty and unfocused.
void | set_placeholder_text (const Glib::ustring &text)
| Sets text to be displayed in entry when it is empty.
void | set_icon_from_paintable (const Glib::RefPtr< Gdk::Paintable > &paintable, IconPosition icon_pos=IconPosition::PRIMARY)
| Sets the icon shown in the specified position using a `Gdk::Paintable`.
void | set_icon_from_icon_name (const Glib::ustring &icon_name, IconPosition icon_pos=IconPosition::PRIMARY)
| Sets the icon shown in the entry at the specified position from the current icon theme.
void | set_icon_from_gicon (const Glib::RefPtr< Gio::Icon > &icon, IconPosition icon_pos=IconPosition::PRIMARY)
| Sets the icon shown in the entry at the specified position from the current icon theme.
void | unset_icon (IconPosition icon_pos=IconPosition::PRIMARY)
| Do not show any icon in the specified position.
Image::Type | get_icon_storage_type (IconPosition icon_pos=IconPosition::PRIMARY) const
| Gets the type of representation being used by the icon to store image data.
Glib::RefPtr< Gdk::Paintable > | get_icon_paintable (IconPosition icon_pos=IconPosition::PRIMARY)
| Retrieves the `Gdk::Paintable` used for the icon.
Glib::RefPtr< const Gdk::Paintable > | get_icon_paintable (IconPosition icon_pos=IconPosition::PRIMARY) const
| Retrieves the `Gdk::Paintable` used for the icon.
Glib::ustring | get_icon_name (IconPosition icon_pos=IconPosition::PRIMARY) const
| Retrieves the icon name used for the icon.
Glib::RefPtr< Gio::Icon > | get_icon_gicon (IconPosition icon_pos=IconPosition::PRIMARY)
| Retrieves the `Gio::Icon` used for the icon.
Glib::RefPtr< const Gio::Icon > | get_icon_gicon (IconPosition icon_pos=IconPosition::PRIMARY) const
| Retrieves the `Gio::Icon` used for the icon.
void | set_icon_activatable (bool activatable=true, IconPosition icon_pos=IconPosition::PRIMARY)
| Sets whether the icon is activatable.
bool | get_icon_activatable (IconPosition icon_pos=IconPosition::PRIMARY) const
| Returns whether the icon is activatable.
void | set_icon_sensitive (IconPosition icon_pos=IconPosition::PRIMARY, bool sensitive=true)
| Sets the sensitivity for the specified icon.
bool | get_icon_sensitive (IconPosition icon_pos=IconPosition::PRIMARY)
| Returns whether the icon appears sensitive or insensitive.
int | get_icon_at_pos (int x, int y) const
| Finds the icon at the given position and return its index.
void | set_icon_tooltip_text (const Glib::ustring &tooltip, IconPosition icon_pos=IconPosition::PRIMARY)
| Sets tooltip as the contents of the tooltip for the icon at the specified position.
Glib::ustring | get_icon_tooltip_text (IconPosition icon_pos=IconPosition::PRIMARY) const
| Gets the contents of the tooltip on the icon at the specified position in entry.
void | set_icon_tooltip_markup (const Glib::ustring &tooltip, IconPosition icon_pos=IconPosition::PRIMARY)
| Sets tooltip as the contents of the tooltip for the icon at the specified position.
Glib::ustring | get_icon_tooltip_markup (IconPosition icon_pos=IconPosition::PRIMARY) const
| Gets the contents of the tooltip on the icon at the specified position in entry.
void | set_icon_drag_source (const Glib::RefPtr< Gdk::ContentProvider > &provider, Gdk::DragAction actions=Gdk::DragAction::COPY, IconPosition icon_pos=IconPosition::PRIMARY)
| Sets up the icon at the given position as drag source.
Gdk::Rectangle | get_icon_area (IconPosition icon_pos=IconPosition::PRIMARY) const
| Returns the area where entry's icon at icon_pos is drawn.
int | get_current_icon_drag_source ()
| Returns the index of the icon which is the source of the current DND operation, or -1.
void | reset_im_context ()
| Reset the input method context of the entry if needed.
void | set_input_purpose (InputPurpose purpose)
| Sets the input purpose which can be used by input methods to adjust their behavior.
InputPurpose | get_input_purpose () const
| Gets the input purpose of the `Gtk::Entry`.
void | set_input_hints (InputHints hints)
| Set additional hints which allow input methods to fine-tune their behavior.
InputHints | get_input_hints () const
| Gets the input hints of this `Gtk::Entry`.
void | set_attributes (Pango::AttrList &attrs)
| Sets a `Pango::AttrList`.
Pango::AttrList | get_attributes () const
| Gets the attribute list of the `Gtk::Entry`.
void | set_tabs (const Pango::TabArray &tabs)
| Sets a `Pango::TabArray`.
Pango::TabArray | get_tabs () const
| Gets the tabstops of the `Gtk::Entry`.
void | grab_focus_without_selecting ()
| Causes entry to have keyboard focus.
void | set_extra_menu (const Glib::RefPtr< Gio::MenuModel > &model)
| Sets a menu model to add when constructing the context menu for entry.
Glib::RefPtr< Gio::MenuModel > | get_extra_menu ()
| Gets the menu model set with set_extra_menu().
Glib::RefPtr< const Gio::MenuModel > | get_extra_menu () const
| Gets the menu model set with set_extra_menu().
Glib::SignalProxy< void()> | signal_activate ()
Glib::SignalProxy< void(IconPosition)> | signal_icon_release ()
Glib::SignalProxy< void(IconPosition)> | signal_icon_press ()
Glib::PropertyProxy< Glib::RefPtr< EntryBuffer > > | property_buffer ()
| The buffer object which actually stores the text.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< EntryBuffer > > | property_buffer () const
| The buffer object which actually stores the text.
Glib::PropertyProxy< int > | property_max_length ()
| Maximum number of characters for this entry.
Glib::PropertyProxy_ReadOnly< int > | property_max_length () const
| Maximum number of characters for this entry.
Glib::PropertyProxy< bool > | property_visibility ()
| Whether the entry should show the “invisible char” instead of the actual text (“password mode”).
Glib::PropertyProxy_ReadOnly< bool > | property_visibility () const
| Whether the entry should show the “invisible char” instead of the actual text (“password mode”).
Glib::PropertyProxy< bool > | property_has_frame ()
| Whether the entry should draw a frame.
Glib::PropertyProxy_ReadOnly< bool > | property_has_frame () const
| Whether the entry should draw a frame.
Glib::PropertyProxy< gunichar > | property_invisible_char ()
| The character to use when masking entry contents (“password mode”).
Glib::PropertyProxy_ReadOnly< gunichar > | property_invisible_char () const
| The character to use when masking entry contents (“password mode”).
Glib::PropertyProxy< bool > | property_invisible_char_set ()
| Whether the invisible char has been set for the `Gtk::Entry`.
Glib::PropertyProxy_ReadOnly< bool > | property_invisible_char_set () const
| Whether the invisible char has been set for the `Gtk::Entry`.
Glib::PropertyProxy< bool > | property_activates_default ()
| Whether to activate the default widget when Enter is pressed.
Glib::PropertyProxy_ReadOnly< bool > | property_activates_default () const
| Whether to activate the default widget when Enter is pressed.
Glib::PropertyProxy_ReadOnly< int > | property_scroll_offset () const
| Number of pixels of the entry scrolled off the screen to the left.
Glib::PropertyProxy< bool > | property_truncate_multiline ()
| When `true`, pasted multi-line text is truncated to the first line.
Glib::PropertyProxy_ReadOnly< bool > | property_truncate_multiline () const
| When `true`, pasted multi-line text is truncated to the first line.
Glib::PropertyProxy< bool > | property_overwrite_mode ()
| If text is overwritten when typing in the `Gtk::Entry`.
Glib::PropertyProxy_ReadOnly< bool > | property_overwrite_mode () const
| If text is overwritten when typing in the `Gtk::Entry`.
Glib::PropertyProxy_ReadOnly< guint > | property_text_length () const
| The length of the text in the `Gtk::Entry`.
Glib::PropertyProxy< double > | property_progress_fraction ()
| The current fraction of the task that's been completed.
Glib::PropertyProxy_ReadOnly< double > | property_progress_fraction () const
| The current fraction of the task that's been completed.
Glib::PropertyProxy< double > | property_progress_pulse_step ()
| The fraction of total entry width to move the progress bouncing block for each pulse.
Glib::PropertyProxy_ReadOnly< double > | property_progress_pulse_step () const
| The fraction of total entry width to move the progress bouncing block for each pulse.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Paintable > > | property_primary_icon_paintable ()
| A `Gdk::Paintable` to use as the primary icon for the entry.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Paintable > > | property_primary_icon_paintable () const
| A `Gdk::Paintable` to use as the primary icon for the entry.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Paintable > > | property_secondary_icon_paintable ()
| A `Gdk::Paintable` to use as the secondary icon for the entry.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Paintable > > | property_secondary_icon_paintable () const
| A `Gdk::Paintable` to use as the secondary icon for the entry.
Glib::PropertyProxy< Glib::ustring > | property_primary_icon_name ()
| The icon name to use for the primary icon for the entry.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_primary_icon_name () const
| The icon name to use for the primary icon for the entry.
Glib::PropertyProxy< Glib::ustring > | property_secondary_icon_name ()
| The icon name to use for the secondary icon for the entry.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_secondary_icon_name () const
| The icon name to use for the secondary icon for the entry.
Glib::PropertyProxy< Glib::RefPtr< Gio::Icon > > | property_primary_icon_gicon ()
| The `Gio::Icon` to use for the primary icon for the entry.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::Icon > > | property_primary_icon_gicon () const
| The `Gio::Icon` to use for the primary icon for the entry.
Glib::PropertyProxy< Glib::RefPtr< Gio::Icon > > | property_secondary_icon_gicon ()
| The `Gio::Icon` to use for the secondary icon for the entry.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::Icon > > | property_secondary_icon_gicon () const
| The `Gio::Icon` to use for the secondary icon for the entry.
Glib::PropertyProxy_ReadOnly< Image::Type > | property_primary_icon_storage_type () const
| The representation which is used for the primary icon of the entry.
Glib::PropertyProxy_ReadOnly< Image::Type > | property_secondary_icon_storage_type () const
| The representation which is used for the secondary icon of the entry.
Glib::PropertyProxy< bool > | property_primary_icon_activatable ()
| Whether the primary icon is activatable.
Glib::PropertyProxy_ReadOnly< bool > | property_primary_icon_activatable () const
| Whether the primary icon is activatable.
Glib::PropertyProxy< bool > | property_secondary_icon_activatable ()
| Whether the secondary icon is activatable.
Glib::PropertyProxy_ReadOnly< bool > | property_secondary_icon_activatable () const
| Whether the secondary icon is activatable.
Glib::PropertyProxy< bool > | property_primary_icon_sensitive ()
| Whether the primary icon is sensitive.
Glib::PropertyProxy_ReadOnly< bool > | property_primary_icon_sensitive () const
| Whether the primary icon is sensitive.
Glib::PropertyProxy< bool > | property_secondary_icon_sensitive ()
| Whether the secondary icon is sensitive.
Glib::PropertyProxy_ReadOnly< bool > | property_secondary_icon_sensitive () const
| Whether the secondary icon is sensitive.
Glib::PropertyProxy< bool > | property_primary_icon_tooltip_text ()
| The contents of the tooltip on the primary icon.
Glib::PropertyProxy_ReadOnly< bool > | property_primary_icon_tooltip_text () const
| The contents of the tooltip on the primary icon.
Glib::PropertyProxy< bool > | property_secondary_icon_tooltip_text ()
| The contents of the tooltip on the secondary icon.
Glib::PropertyProxy_ReadOnly< bool > | property_secondary_icon_tooltip_text () const
| The contents of the tooltip on the secondary icon.
Glib::PropertyProxy< bool > | property_primary_icon_tooltip_markup ()
| The contents of the tooltip on the primary icon, with markup.
Glib::PropertyProxy_ReadOnly< bool > | property_primary_icon_tooltip_markup () const
| The contents of the tooltip on the primary icon, with markup.
Glib::PropertyProxy< bool > | property_secondary_icon_tooltip_markup ()
| The contents of the tooltip on the secondary icon, with markup.
Glib::PropertyProxy_ReadOnly< bool > | property_secondary_icon_tooltip_markup () const
| The contents of the tooltip on the secondary icon, with markup.
Glib::PropertyProxy< Glib::ustring > | property_im_module ()
| Which IM (input method) module should be used for this entry.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_im_module () const
| Which IM (input method) module should be used for this entry.
Glib::PropertyProxy< Glib::ustring > | property_placeholder_text ()
| The text that will be displayed in the `Gtk::Entry` when it is empty and unfocused.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_placeholder_text () const
| The text that will be displayed in the `Gtk::Entry` when it is empty and unfocused.
Glib::PropertyProxy< Glib::RefPtr< EntryCompletion > > | property_completion ()
| The auxiliary completion object to use with the entry.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< EntryCompletion > > | property_completion () const
| The auxiliary completion object to use with the entry.
Glib::PropertyProxy< InputPurpose > | property_input_purpose ()
| The purpose of this text field.
Glib::PropertyProxy_ReadOnly< InputPurpose > | property_input_purpose () const
| The purpose of this text field.
Glib::PropertyProxy< InputHints > | property_input_hints ()
| Additional hints that allow input methods to fine-tune their behavior.
Glib::PropertyProxy_ReadOnly< InputHints > | property_input_hints () const
| Additional hints that allow input methods to fine-tune their behavior.
Glib::PropertyProxy< Pango::AttrList > | property_attributes ()
| A list of Pango attributes to apply to the text of the entry.
Glib::PropertyProxy_ReadOnly< Pango::AttrList > | property_attributes () const
| A list of Pango attributes to apply to the text of the entry.
Glib::PropertyProxy< Pango::TabArray > | property_tabs ()
Glib::PropertyProxy_ReadOnly< Pango::TabArray > | property_tabs () const
Glib::PropertyProxy< Glib::RefPtr< Gio::MenuModel > > | property_extra_menu ()
| A menu model whose contents will be appended to the context menu.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::MenuModel > > | property_extra_menu () const
| A menu model whose contents will be appended to the context menu.
Glib::PropertyProxy< bool > | property_show_emoji_icon ()
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_show_emoji_icon () const
| Default value: `false`
Glib::PropertyProxy< bool > | property_enable_emoji_completion ()
| Whether to suggest Emoji replacements for :-delimited names like `:heart:`.
Glib::PropertyProxy_ReadOnly< bool > | property_enable_emoji_completion () const
| Whether to suggest Emoji replacements for :-delimited names like `:heart:`.
Public Member Functions inherited from Gtk::Widget
| Widget (Widget &&src) noexcept
Widget & | operator= (Widget &&src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget.
GtkWidget * | gobj ()
| Provides access to the underlying C GObject.
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget.
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget.
void | show ()
| Flags a widget to be displayed.
void | hide ()
| Reverses the effects of show().
void | queue_draw ()
| Schedules this widget to be redrawn in the paint phase of the current or the next frame.
void | queue_resize ()
| Flags a widget to have its size renegotiated.
void | queue_allocate ()
| Flags the widget for a rerun of the size_allocate_vfunc() function.
void | size_allocate (const Allocation &allocation, int baseline)
| Allocates widget with a transformation that translates the origin to the position in allocation.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | measure (Orientation orientation, int for_size, int & minimum, int & natural, int &minimum_baseline, int &natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size.
Measurements | measure (Orientation orientation, int for_size=-1) const
| Like the other overload of measure() but returns a structure holding the sizes/baselines instead of using output parameters.
void | get_preferred_size (Requisition &minimum_size, Requisition &natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management.
PreferredSize | get_preferred_size () const
| Like the other overload of get_preferred_size() but returns a structure holding the sizes instead of using output parameters.
void | set_layout_manager (const Glib::RefPtr< LayoutManager > &layout_manager)
| Sets the layout manager delegate instance that provides an implementation for measuring and allocating the children of widget.
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager().
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager used by widget.
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager used by widget.
bool | mnemonic_activate (bool group_cycling)
| Emits the signal_mnemonic_activate() signal.
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them.
void | set_can_focus (bool can_focus=true)
| Specifies whether the input focus can enter the widget or any of its children.
bool | get_can_focus () const
| Determines whether the input focus can enter widget or any of its children.
void | set_focusable (bool focusable=true)
| Specifies whether widget can own the input focus.
bool | get_focusable () const
| Determines whether widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus.
bool | grab_focus ()
| Causes widget to have the keyboard focus for the `Gtk::Window` it's inside.
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse.
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse.
void | set_can_target (bool can_target=true)
| Sets whether widget can be the target of pointer events.
bool | get_can_target () const
| Queries whether widget can be the target of pointer events.
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel.
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
void | set_name (const Glib::ustring & name)
| Sets a widgets name.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state_flags (StateFlags flags, bool clear=true)
| Turns on flag values in the current widget state.
void | unset_state_flags (StateFlags flags)
| Turns off flag values for the current widget state.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget.
bool | get_sensitive () const
| Returns the widget’s sensitivity.
bool | is_sensitive () const
| Returns the widget’s effective sensitivity.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible.
bool | is_drawable () const
| Determines whether widget can be drawn to.
bool | get_realized () const
| Determines whether widget is realized.
bool | get_mapped () const
| Whether the widget is mapped.
void | set_child_visible (bool visible=true)
| Sets whether widget should be mapped along with its parent.
bool | get_child_visible () const
| Gets the value set with set_child_visible().
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget.
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to widget.
Allocation | get_allocation () const
| Retrieves the widget’s location.
std::optional< Gdk::Graphene::Rect > | compute_bounds (const Widget & target) const
| Computes the bounds for the widget in the coordinate space of target.
std::optional< Gdk::Graphene::Point > | compute_point (const Widget & target, const Gdk::Graphene::Point &point) const
| Translates the given point in the widget's coordinates to coordinates relative to target’s coordinate system.
int | get_width () const
| Returns the content width of the widget.
int | get_height () const
| Returns the content height of the widget.
int | get_baseline () const
| Returns the baseline that has currently been allocated to widget.
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget.
Widget * | get_parent ()
| Returns the parent widget of widget.
const Widget * | get_parent () const
| Returns the parent widget of widget.
Root * | get_root ()
| Returns the `Gtk::Root` widget of widget.
const Root * | get_root () const
| Returns the `Gtk::Root` widget of widget.
Native * | get_native ()
| Returns the nearest `Gtk::Native` ancestor of widget.
const Native * | get_native () const
| Returns the nearest `Gtk::Native` ancestor of widget.
bool | child_focus (DirectionType direction)
| Called by widgets as the user moves around the window using keyboard shortcuts.
bool | keynav_failed (DirectionType direction)
| Emits the `keynav-failed` signal on the widget.
void | error_bell ()
| Notifies the user about an input-related error on this widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget.
void | get_size_request (int & width, int &height) const
| Gets the size request that was explicitly set for the widget using set_size_request().
Requisition | get_size_request () const
| Like the other overload of get_size_request() but returns a structure holding the sizes instead of using output parameters.
void | set_opacity (double opacity)
| Request the widget to be rendered partially transparent.
double | get_opacity () const
| Fetches the requested opacity for this widget.
void | set_overflow (Overflow overflow)
| Sets how widget treats content that is drawn outside the widget's content area.
Overflow | get_overflow () const
| Returns the widget’s overflow value.
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type.
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type.
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the `Gdk::Display` for the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the `Gdk::Display` for the toplevel window associated with this widget.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget.
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| Gets the clipboard object for widget.
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| Gets the clipboard object for widget.
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| Gets the primary clipboard of widget.
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| Gets the primary clipboard of widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag will be used.
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible.
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions.
Align | get_halign () const
| Gets the horizontal alignment of widget.
void | set_halign (Align align)
| Sets the horizontal alignment of widget.
Align | get_valign () const
| Gets the vertical alignment of widget.
void | set_valign (Align align)
| Sets the vertical alignment of widget.
int | get_margin_start () const
| Gets the start margin of widget.
void | set_margin_start (int margin)
| Sets the start margin of widget.
int | get_margin_end () const
| Gets the end margin of widget.
void | set_margin_end (int margin)
| Sets the end margin of widget.
int | get_margin_top () const
| Gets the top margin of widget.
void | set_margin_top (int margin)
| Sets the top margin of widget.
int | get_margin_bottom () const
| Gets the bottom margin of widget.
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget.
void | set_margin (int margin)
| Set all 4 margins to the same value.
bool | is_ancestor (Widget &ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.
bool | translate_coordinates (Widget &dest_widget, double src_x, double src_y, double &dest_x, double &dest_y)
| Translate coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations.
bool | contains (double x, double y) const
| Tests if the point at ( x, y) is contained in widget.
Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of widget closest to the point ( x, y).
const Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of widget closest to the point ( x, y).
void | add_controller (const Glib::RefPtr< EventController > &controller)
| Adds controller to widget so that it will receive events.
void | remove_controller (const Glib::RefPtr< EventController > &controller)
| Removes controller from widget, so that it doesn't process events anymore.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new `Pango::Context` with the appropriate font map, font options, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a `Pango::Context` with the appropriate font map, font description, and base direction for this widget.
void | set_font_options (const Cairo::FontOptions &options)
| Sets the `cairo_font_options_t` used for Pango rendering in this widget.
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options().
Cairo::FontOptions | get_font_options () const
| Returns the `cairo_font_options_t` of widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring &text)
| Creates a new `Pango::Layout` with the appropriate font map, font description, and base direction for drawing text for this widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget.
TextDirection | get_direction () const
| Gets the reading direction for a particular widget.
void | set_cursor (const Glib::RefPtr< Gdk::Cursor > &cursor)
| Sets the cursor to be shown when pointer devices point towards widget.
void | set_cursor (const Glib::ustring & name={})
| Sets a named cursor to be shown when pointer devices point towards the widget.
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Queries the cursor set on widget.
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Queries the cursor set on widget.
std::vector< Widget * > | list_mnemonic_labels ()
| Returns the widgets for which this widget is the target of a mnemonic.
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns the widgets for which this widget is the target of a mnemonic.
void | add_mnemonic_label (Widget &label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget &label)
| Removes a widget from the list of mnemonic labels for this widget.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a drag movement has passed the GTK drag threshold.
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget.
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget.
void | set_parent (Widget & parent)
| Sets parent as the parent widget of widget.
void | unparent ()
| Dissociate widget from its parent.
void | map ()
| Causes a widget to be mapped if it isn’t already.
void | unmap ()
| Causes a widget to be unmapped if it’s currently mapped.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located.
void | set_tooltip_text (const Glib::ustring &text)
| Sets text as the contents of the tooltip.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget.
void | set_tooltip_markup (const Glib::ustring &markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the `has-tooltip` property on widget to has_tooltip.
bool | get_has_tooltip () const
| Returns the current value of the `has-tooltip` property.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget.
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to widget.
guint | add_tick_callback (const SlotTick &slot)
| Queues an animation frame update and adds a callback to be called before each frame.
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback().
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts group into widget.
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget.
bool | activate_action (const Glib::ustring & name, const Glib::VariantBase &args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it.
void | activate_default ()
| Activates the `default.activate` action from widget.
void | set_font_map (const Glib::RefPtr< Pango::FontMap > &font_map)
| Sets the font map to use for Pango rendering.
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map of widget.
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map of widget.
Widget * | get_first_child ()
| Returns the widget’s first child.
const Widget * | get_first_child () const
| Returns the widget’s first child.
Widget * | get_last_child ()
| Returns the widget’s last child.
const Widget * | get_last_child () const
| Returns the widget’s last child.
Widget * | get_next_sibling ()
| Returns the widget’s next sibling.
const Widget * | get_next_sibling () const
| Returns the widget’s next sibling.
Widget * | get_prev_sibling ()
| Returns the widget’s previous sibling.
const Widget * | get_prev_sibling () const
| Returns the widget’s previous sibling.
std::vector< Widget * > | get_children ()
| Gets a vector of the widgetʼs current children, from first child to last.
std::vector< const Widget * > | get_children () const
| Gets a vector of the widgetʼs current children, from first child to last.
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a `Gio::ListModel` to track the children of widget.
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a `Gio::ListModel` to track the children of widget.
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget.
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget.
void | insert_after (Widget & parent, const Widget &previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling.
void | insert_before (Widget & parent, const Widget &next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling.
void | insert_at_start (Widget & parent)
| Inserts the Widget at the beginning of the child widget list of parent.
void | insert_at_end (Widget & parent)
| Inserts the Widget at the end of the child widget list of parent.
void | snapshot_child (Widget &child, const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Snapshot the a child of widget.
bool | should_layout () const
| Returns whether widget should contribute to the measuring and allocation of its parent.
Glib::ustring | get_css_name () const
| Returns the CSS name that is used for self.
void | add_css_class (const Glib::ustring &css_class)
| Adds a style class to widget.
void | remove_css_class (const Glib::ustring &css_class)
| Removes a style from widget.
bool | has_css_class (const Glib::ustring &css_class) const
| Returns whether css_class is currently applied to widget.
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of style classes applied to widget.
void | set_css_classes (const std::vector< Glib::ustring > &classes)
| Clear all style classes applied to widget and replace them with classes.
Gdk::RGBA | get_color () const
| Gets the current foreground color for the widget's CSS style.
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_destroy ()
| Emitted during the dispose phase.
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Widget * > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly< Root * > | property_root () const
| The `Gtk::Root` widget of the widget tree containing this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget.
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events.
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events.
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the `hexpand` property.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the `hexpand` property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the `vexpand` property.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the `vexpand` property.
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget.
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget.
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree.
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget.
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget.
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children.
Public Member Functions inherited from Gtk::Object
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible &&src) noexcept
Accessible & | operator= (Accessible &&src) noexcept
| ~Accessible () noexcept override
GtkAccessible * | gobj ()
| Provides access to the underlying C GObject.
const GtkAccessible * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ATContext > | get_at_context ()
| Retrieves the accessible implementation for the given `Gtk::Accessible`.
Glib::RefPtr< const ATContext > | get_at_context () const
| Retrieves the accessible implementation for the given `Gtk::Accessible`.
bool | get_platform_state (PlatformState state) const
| Query a platform state, such as focus.
Glib::RefPtr< Accessible > | get_accessible_parent ()
| Retrieves the accessible parent for an accessible object.
Glib::RefPtr< const Accessible > | get_accessible_parent () const
| Retrieves the accessible parent for an accessible object.
void | set_accessible_parent (const Glib::RefPtr< Accessible > & parent, const Glib::RefPtr< Accessible > &next_sibling)
| Sets the parent and sibling of an accessible object.
Glib::RefPtr< Accessible > | get_first_accessible_child ()
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< const Accessible > | get_first_accessible_child () const
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< Accessible > | get_next_accessible_sibling ()
| Retrieves the next accessible sibling of an accessible object.
Glib::RefPtr< const Accessible > | get_next_accessible_sibling () const
| Retrieves the next accessible sibling of an accessible object.
void | update_next_accessible_sibling (const Glib::RefPtr< Accessible > &new_sibling)
| Updates the next accessible sibling of self.
bool | get_bounds (int &x, int &y, int & width, int &height) const
| Queries the coordinates and dimensions of this accessible.
Role | get_accessible_role () const
| Retrieves the accessible role of an accessible object.
void | update_state (State state, const Glib::ValueBase & value)
| Updates an accessible state.
void | update_property (Property property, const Glib::ValueBase & value)
| Updates an accessible property.
void | update_relation (Relation relation, const Glib::ValueBase & value)
| Updates an accessible relation.
void | reset_state (State state)
| Resets the accessible state to its default value.
void | reset_property (Property property)
| Resets the accessible property to its default value.
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value.
void | announce (const Glib::ustring & message, AnnouncementPriority priority)
| Requests the user's screen reader to announce the given message.
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given `Gtk::Accessible` implementation.
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given `Gtk::Accessible` implementation.
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable &&src) noexcept
Buildable & | operator= (Buildable &&src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget &&src) noexcept
ConstraintTarget & | operator= (ConstraintTarget &&src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget * | gobj ()
| Provides access to the underlying C GObject.
const GtkConstraintTarget * | gobj () const
| Provides access to the underlying C GObject.
Public Member Functions inherited from Gtk::Editable
| Editable (Editable &&src) noexcept
Editable & | operator= (Editable &&src) noexcept
| ~Editable () noexcept override
GtkEditable * | gobj ()
| Provides access to the underlying C GObject.
const GtkEditable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_text () const
| Retrieves the contents of editable.
void | set_text (const Glib::ustring &text)
| Sets the text in the editable to the given value.
void | delete_selection ()
| Deletes the currently selected text of the editable.
void | set_editable (bool is_editable=true)
| Determines if the user can edit the text in the editable widget.
bool | get_editable () const
| Retrieves whether editable is editable.
void | insert_text (const Glib::ustring &new_text, int new_text_length, int & position)
| Inserts new_text_length bytes of new_text into the contents of the widget, at position position.
void | delete_text (int start_pos, int end_pos)
| Deletes a sequence of characters.
Glib::ustring | get_chars (int start_pos, int end_pos) const
| Retrieves a sequence of characters.
void | select_region (int start_pos, int end_pos)
| Selects a region of text.
bool | get_selection_bounds (int &start_pos, int &end_pos) const
| Retrieves the selection bound of the editable.
void | set_position (int position)
| Sets the cursor position in the editable to the given value.
int | get_position () const
| Retrieves the current position of the cursor relative to the start of the content of the editable.
float | get_alignment () const
| Gets the alignment of the editable.
void | set_alignment (float xalign)
| Sets the alignment for the contents of the editable.
int | get_width_chars () const
| Gets the number of characters of space reserved for the contents of the editable.
void | set_width_chars (int n_chars)
| Changes the size request of the editable to be about the right size for n_chars characters.
int | get_max_width_chars () const
| Retrieves the desired maximum width of editable, in characters.
void | set_max_width_chars (int n_chars)
| Sets the desired maximum width in characters of editable.
bool | get_enable_undo () const
| Gets if undo/redo actions are enabled for editable.
void | set_enable_undo (bool enable_undo=true)
| If enabled, changes to editable will be saved for undo/redo actions.
Glib::SignalProxy< void(int, int)> | signal_delete_text ()
Glib::SignalProxy< void()> | signal_changed ()
Glib::PropertyProxy< Glib::ustring > | property_text ()
| The contents of the entry.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_text () const
| The contents of the entry.
Glib::PropertyProxy_ReadOnly< int > | property_cursor_position () const
| The current position of the insertion cursor in chars.
Glib::PropertyProxy< bool > | property_enable_undo ()
| If undo/redo should be enabled for the editable.
Glib::PropertyProxy_ReadOnly< bool > | property_enable_undo () const
| If undo/redo should be enabled for the editable.
Glib::PropertyProxy_ReadOnly< int > | property_selection_bound () const
| The position of the opposite end of the selection from the cursor in chars.
Glib::PropertyProxy< bool > | property_editable ()
| Whether the entry contents can be edited.
Glib::PropertyProxy_ReadOnly< bool > | property_editable () const
| Whether the entry contents can be edited.
Glib::PropertyProxy< int > | property_width_chars ()
| Number of characters to leave space for in the entry.
Glib::PropertyProxy_ReadOnly< int > | property_width_chars () const
| Number of characters to leave space for in the entry.
Glib::PropertyProxy< int > | property_max_width_chars ()
| The desired maximum width of the entry, in characters.
Glib::PropertyProxy_ReadOnly< int > | property_max_width_chars () const
| The desired maximum width of the entry, in characters.
Glib::PropertyProxy< float > | property_xalign ()
| The horizontal alignment, from 0 (left) to 1 (right).
Glib::PropertyProxy_ReadOnly< float > | property_xalign () const
| The horizontal alignment, from 0 (left) to 1 (right).
Public Member Functions inherited from Gtk::CellEditable
| CellEditable (CellEditable &&src) noexcept
CellEditable & | operator= (CellEditable &&src) noexcept
| ~CellEditable () noexcept override
GtkCellEditable * | gobj ()
| Provides access to the underlying C GObject.
const GtkCellEditable * | gobj () const
| Provides access to the underlying C GObject.
void | start_editing (const Glib::RefPtr< const Gdk::Event > & event)
| Begins editing on a cell_editable.
void | editing_done ()
| Emits the `GtkCellEditable::editing-done` signal.
void | remove_widget ()
| Emits the `GtkCellEditable::remove-widget` signal.
Glib::SignalProxy< void()> | signal_editing_done ()
Glib::SignalProxy< void()> | signal_remove_widget ()
Glib::PropertyProxy< bool > | property_editing_canceled ()
| Indicates whether editing on the cell has been canceled.
Glib::PropertyProxy_ReadOnly< bool > | property_editing_canceled () const
| Indicates whether editing on the cell has been canceled.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Entry
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets.
static TextDirection | get_default_direction ()
| Obtains the current default reading direction.
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Editable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::CellEditable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Gtk::SearchEntry * | wrap (GtkSearchEntry *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Entry
Gtk::Entry * | wrap (GtkEntry *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Widget
Gtk::Widget * | wrap (GtkWidget *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Editable
Glib::RefPtr< Gtk::Editable > | wrap (GtkEditable *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::CellEditable
Glib::RefPtr< Gtk::CellEditable > | wrap (GtkCellEditable *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Gtk::Entry
enum class | IconPosition { IconPosition::PRIMARY , IconPosition::SECONDARY }
| Specifies the side of the entry at which an icon is placed. More...
Public Types inherited from Gtk::Widget
using | PreferredSize = MinimumNatural<Requisition>
| Structure returned by the non-output-parameter overload of get_preferred_size().
using | SlotTick = sigc::slot<bool(const Glib::RefPtr<Gdk::FrameClock>&)>
| Callback type for adding a function to update animations.
Public Types inherited from Gtk::Accessible
enum class | Role { Role::ALERT , Role::ALERT_DIALOG , Role::BANNER , Role::BUTTON , Role::CAPTION , Role::CELL , Role::CHECKBOX , Role::COLUMN_HEADER , Role::COMBO_BOX , Role::COMMAND , Role::COMPOSITE , Role::DIALOG , Role::DOCUMENT , Role::FEED , Role::FORM , Role::GENERIC , Role::GRID , Role::GRID_CELL , Role::GROUP , Role::HEADING , Role::IMG , Role::INPUT , Role::LABEL , Role::LANDMARK , Role::LEGEND , Role::LINK , Role::LIST , Role::LIST_BOX , Role::LIST_ITEM , Role::LOG , Role::MAIN , Role::MARQUEE , Role::MATH , Role::METER , Role::MENU , Role::MENU_BAR , Role::MENU_ITEM , Role::MENU_ITEM_CHECKBOX , Role::MENU_ITEM_RADIO , Role::NAVIGATION , Role::NONE , Role::NOTE , Role::OPTION , Role::PRESENTATION , Role::PROGRESS_BAR , Role::RADIO , Role::RADIO_GROUP , Role::RANGE , Role::REGION , Role::ROW , Role::ROW_GROUP , Role::ROW_HEADER , Role::SCROLLBAR , Role::SEARCH , Role::SEARCH_BOX , Role::SECTION , Role::SECTION_HEAD , Role::SELECT , Role::SEPARATOR , Role::SLIDER , Role::SPIN_BUTTON , Role::STATUS , Role::STRUCTURE , Role::SWITCH , Role::TAB , Role::TABLE , Role::TAB_LIST , Role::TAB_PANEL , Role::TEXT_BOX , Role::TIME , Role::TIMER , Role::TOOLBAR , Role::TOOLTIP , Role::TREE , Role::TREE_GRID , Role::TREE_ITEM , Role::WIDGET , Role::WINDOW , Role::TOGGLE_BUTTON , Role::APPLICATION , Role::PARAGRAPH , Role::BLOCK_QUOTE , Role::ARTICLE , Role::COMMENT , Role::TERMINAL }
| The accessible role for a Gtk::Accessible implementation. More...
enum class | State { State::BUSY , State::CHECKED , State::DISABLED , State::EXPANDED , State::HIDDEN , State::INVALID , State::PRESSED , State::SELECTED , State::VISITED }
| The possible accessible states of a Gtk::Accessible. More...
enum class | Property { Property::AUTOCOMPLETE , Property::DESCRIPTION , Property::HAS_POPUP , Property::KEY_SHORTCUTS , Property::LABEL , Property::LEVEL , Property::MODAL , Property::MULTI_LINE , Property::MULTI_SELECTABLE , Property::ORIENTATION , Property::PLACEHOLDER , Property::READ_ONLY , Property::REQUIRED , Property::ROLE_DESCRIPTION , Property::SORT , Property::VALUE_MAX , Property::VALUE_MIN , Property::VALUE_NOW , Property::VALUE_TEXT }
| The possible accessible properties of a Gtk::Accessible. More...
enum class | Relation { Relation::ACTIVE_DESCENDANT , Relation::COL_COUNT , Relation::COL_INDEX , Relation::COL_INDEX_TEXT , Relation::COL_SPAN , Relation::CONTROLS , Relation::DESCRIBED_BY , Relation::DETAILS , Relation::ERROR_MESSAGE , Relation::FLOW_TO , Relation::LABELLED_BY , Relation::OWNS , Relation::POS_IN_SET , Relation::ROW_COUNT , Relation::ROW_INDEX , Relation::ROW_INDEX_TEXT , Relation::ROW_SPAN , Relation::SET_SIZE }
| The possible accessible relations of a Gtk::Accessible. More...
enum class | PlatformState { PlatformState::FOCUSABLE , PlatformState::FOCUSED , PlatformState::ACTIVE }
| The various platform states which can be queried using Gtk::Accessible::get_platform_state(). More...
enum class | AnnouncementPriority { AnnouncementPriority::LOW , AnnouncementPriority::MEDIUM , AnnouncementPriority::HIGH }
| The priority of an accessibility announcement. More...
Public Attributes inherited from Gtk::Widget
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &) | signal_query_tooltip )()
Public Attributes inherited from Gtk::Editable
Glib::SignalProxy< void(const Glib::ustring &, int *) | signal_insert_text )()
Protected Member Functions inherited from Gtk::Widget
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int & minimum, int & natural, int &minimum_baseline, int &natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget *child)
| Sets the focused child of widget.
virtual void | compute_expand_vfunc (bool &hexpand_p, bool &vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Widget ()
void | realize ()
| Creates the GDK resources associated with a widget.
void | unrealize ()
| Causes a widget to be unrealized (frees all GDK resources associated with the widget).
void | realize_if_needed ()
void | set_focus_child (Widget &child)
| Set child as the current focus child of widget.
void | unset_focus_child ()
| Unsets the focus child of the widget.
Widget * | get_focus_child ()
| Returns the current focus child of widget.
const Widget * | get_focus_child () const
| Returns the current focus child of widget.
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip > &tooltip)
| This is a default handler for the signal signal_query_tooltip().
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Editable
| Editable ()
| You should derive from this class to use it.
virtual void | delete_text_vfunc (int start_pos, int end_pos)
virtual Glib::ustring | get_text_vfunc () const
virtual void | select_region_vfunc (int start_pos, int end_pos)
virtual bool | get_selection_bounds_vfunc (int &start_pos, int &end_pos) const
virtual void | insert_text_vfunc (const Glib::ustring &text, int & position)
virtual void | on_insert_text (const Glib::ustring &text, int * position)
| This is a default handler for the signal signal_insert_text().
virtual void | on_delete_text (int start_pos, int end_pos)
| This is a default handler for the signal signal_delete_text().
virtual void | on_changed ()
| This is a default handler for the signal signal_changed().
Protected Member Functions inherited from Gtk::CellEditable
| CellEditable ()
| You should derive from this class to use it.
virtual void | start_editing_vfunc (const Glib::RefPtr< const Gdk::Event > & event)
virtual void | on_editing_done ()
| This is a default handler for the signal signal_editing_done().
virtual void | on_remove_widget ()
| This is a default handler for the signal signal_remove_widget().

## Detailed Description

This is a subclass of Gtk::Entry that has been tailored for use as a search entry.

It will show an inactive symbolic "find" icon when the search entry is empty, and a symbolic "clear" icon when there is text. Clicking on the "clear" icon will empty the search entry.

Note that the search/clear icon is shown using a secondary icon, and thus does not work if you are using the secondary icon position for some other purpose.

To make filtering appear more reactive, it is a good idea to not react to every change in the entry text immediately, but only after a short delay. To support this, Gtk::SearchEntry emits the signal_search_changed() signal which can be used instead of the Gtk::Editable::signal_changed() signal.

The signal_previous_match(), signal_next_match() and signal_stop_search() signals can be uesd to implement moving between search results and ending the search.

Often, Gtk::SearchEntry will be fed events by means of being placed inside a Gtk::SearchBar. If that is not the case, you can use set_key_capture_widget() to let it capture key input from another widget.

Note
  This class has the wrong inheritance. It inherits from Gtk::Entry although the wrapped GtkSearchEntry does not inherit from GtkEntry in gtk4. Some uses of Gtk::SearchEntry still succeed, others don't. It's highly recommended that you use Gtk::Application::wrap_in_search_entry2() and Gtk::SearchEntry2 instead. Don't use both Gtk::SearchEntry and Gtk::SearchEntry2 in the same application.

Deprecated
  4.14: Use Gtk::SearchEntry2 instead.

Since gtkmm 3.6

## Constructor & Destructor Documentation

## ◆ SearchEntry() [1/3]

Gtk::SearchEntry::SearchEntry | ( | SearchEntry && | src | ) |
| noexcept

## ◆ SearchEntry() [2/3]

Gtk::SearchEntry::SearchEntry | ( | const SearchEntry & |  | ) |
| delete

## ◆ ~SearchEntry()

Gtk::SearchEntry::~SearchEntry | ( |  | ) |
| overridenoexcept

## ◆ SearchEntry() [3/3]

Gtk::SearchEntry::SearchEntry | ( |  | ) |

## Member Function Documentation

## ◆ get_key_capture_widget() [1/2]

Widget * Gtk::SearchEntry::get_key_capture_widget | ( |  | ) |

Gets the widget that entry is capturing key events from.

Returns
  The key capture widget.

## ◆ get_key_capture_widget() [2/2]

const Widget * Gtk::SearchEntry::get_key_capture_widget | ( |  | ) | const

Gets the widget that entry is capturing key events from.

Returns
  The key capture widget.

## ◆ get_placeholder_text()

Glib::ustring Gtk::SearchEntry::get_placeholder_text | ( |  | ) | const

Gets the placeholder text associated with entry.

Since gtkmm 4.10

Returns
  The placeholder text.

## ◆ get_search_delay()

unsigned int Gtk::SearchEntry::get_search_delay | ( |  | ) | const

Get the delay to be used between the last keypress and the signal_search_changed() signal being emitted.

Since gtkmm 4.8

Returns
  A delay in milliseconds.

## ◆ get_type()

static GType Gtk::SearchEntry::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkSearchEntry * Gtk::SearchEntry::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkSearchEntry * Gtk::SearchEntry::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=() [1/2]

SearchEntry & Gtk::SearchEntry::operator= | ( | const SearchEntry & |  | ) |
| delete

## ◆ operator=() [2/2]

SearchEntry & Gtk::SearchEntry::operator= | ( | SearchEntry && | src | ) |
| noexcept

## ◆ property_activates_default() [1/2]

Glib::PropertyProxy< bool > Gtk::SearchEntry::property_activates_default | ( |  | ) |

Whether to activate the default widget when Enter is pressed.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_activates_default() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::SearchEntry::property_activates_default | ( |  | ) | const

Whether to activate the default widget when Enter is pressed.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_placeholder_text() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::SearchEntry::property_placeholder_text | ( |  | ) |

The text that will be displayed in the `Gtk::SearchEntry` when it is empty and unfocused.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_placeholder_text() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::SearchEntry::property_placeholder_text | ( |  | ) | const

The text that will be displayed in the `Gtk::SearchEntry` when it is empty and unfocused.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_search_delay() [1/2]

Glib::PropertyProxy< unsigned int > Gtk::SearchEntry::property_search_delay | ( |  | ) |

The delay in milliseconds from last keypress to the search changed signal.

Since gtkmm 4.8

Default value: 150

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_search_delay() [2/2]

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::SearchEntry::property_search_delay | ( |  | ) | const

The delay in milliseconds from last keypress to the search changed signal.

Since gtkmm 4.8

Default value: 150

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_key_capture_widget()

void Gtk::SearchEntry::set_key_capture_widget | ( | Widget & | widget | ) |

Sets widget as the widget that entry will capture key events from.

Key events are consumed by the search entry to start or continue a search.

If the entry is part of a `Gtk::SearchBar`, it is preferable to call Gtk::SearchBar::set_key_capture_widget() instead, which will reveal the entry in addition to triggering the search entry.

Note that despite the name of this function, the events are only 'captured' in the bubble phase, which means that editable child widgets of widget will receive text input before it gets captured. If that is not desired, you can capture and forward the events yourself with Gtk::EventControllerKey::forward().

Parameters

  widget | A `Gtk::Widget`.

## ◆ set_placeholder_text()

void Gtk::SearchEntry::set_placeholder_text | ( | const Glib::ustring & | text | ) |

Sets the placeholder text associated with entry.

Since gtkmm 4.10

Parameters

  text | The text to set as a placeholder.

## ◆ set_search_delay()

void Gtk::SearchEntry::set_search_delay | ( | unsigned int | delay | ) |

Set the delay to be used between the last keypress and the signal_search_changed() signal being emitted.

Since gtkmm 4.8

Parameters

  delay | A delay in milliseconds.

## ◆ signal_next_match()

Glib::SignalProxy< void()> Gtk::SearchEntry::signal_next_match | ( |  | ) |

Slot Prototype:
  `void on_my_next_match()`

Flags: Run Last, Action

Emitted when the user initiates a move to the next match for the current search string.

This is a keybinding signal.

Applications should connect to it, to implement moving between matches.

The default bindings for this signal is Ctrl-g.

## ◆ signal_previous_match()

Glib::SignalProxy< void()> Gtk::SearchEntry::signal_previous_match | ( |  | ) |

Slot Prototype:
  `void on_my_previous_match()`

Flags: Run Last, Action

Emitted when the user initiates a move to the previous match for the current search string.

This is a keybinding signal.

Applications should connect to it, to implement moving between matches.

The default bindings for this signal is Ctrl-Shift-g.

## ◆ signal_search_changed()

Glib::SignalProxy< void()> Gtk::SearchEntry::signal_search_changed | ( |  | ) |

Slot Prototype:
  `void on_my_search_changed()`

Flags: Run Last

Emitted with a delay. The length of the delay can be changed with the property_search_delay() property.

## ◆ signal_search_started()

Glib::SignalProxy< void()> Gtk::SearchEntry::signal_search_started | ( |  | ) |

Slot Prototype:
  `void on_my_search_started()`

Flags: Run Last

Emitted when the user initiated a search on the entry.

## ◆ signal_stop_search()

Glib::SignalProxy< void()> Gtk::SearchEntry::signal_stop_search | ( |  | ) |

Slot Prototype:
  `void on_my_stop_search()`

Flags: Run Last, Action

Emitted when the user stops a search via keyboard input.

This is a keybinding signal.

Applications should connect to it, to implement hiding the search entry in this case.

The default bindings for this signal is Escape.

## ◆ unset_key_capture_widget()

void Gtk::SearchEntry::unset_key_capture_widget | ( |  | ) |

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::SearchEntry * wrap | ( | GtkSearchEntry * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.